Index: G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/config_gram.c
===================================================================
--- G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/config_gram.c	(revision 1)
+++ G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/config_gram.c	(working copy)
@@ -1589,379 +2242,457 @@
           break;
       }
 
-      free_token(yyvsp[-2]);
-    ;
-    break;}
-case 96:
-#line 720 "../config_gram.y"
-{ 
+      free_token((yyvsp[-2]));
+    }
+    break;
+
+  case 99:
+#line 738 "../config_gram.y"
+    { 
       current_mem = avr_new_memtype(); 
-      strcpy(current_mem->desc, strdup(yyvsp[0]->value.string)); 
-      free_token(yyvsp[0]); 
-    ;
-    break;}
-case 97:
-#line 726 "../config_gram.y"
-{ 
+      strcpy(current_mem->desc, strdup((yyvsp[0])->value.string)); 
+      free_token((yyvsp[0])); 
+    }
+    break;
+
+  case 100:
+#line 744 "../config_gram.y"
+    { 
       ladd(current_part->mem, current_mem); 
       current_mem = NULL; 
-    ;
-    break;}
-case 98:
-#line 731 "../config_gram.y"
-{
+    }
+    break;
+
+  case 101:
+#line 749 "../config_gram.y"
+    {
     { 
       int opnum;
       OPCODE * op;
 
-      opnum = which_opcode(yyvsp[-2]);
+      opnum = which_opcode((yyvsp[-2]));
       op = avr_new_opcode();
       parse_cmdbits(op);
       current_part->op[opnum] = op;
 
-      free_token(yyvsp[-2]);
+      free_token((yyvsp[-2]));
     }
-  ;
-    break;}
-case 103:
-#line 760 "../config_gram.y"
-{
-      current_mem->paged = yyvsp[0]->primary == K_YES ? 1 : 0;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 104:
-#line 766 "../config_gram.y"
-{
-      current_mem->size = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 105:
-#line 773 "../config_gram.y"
-{
-      current_mem->page_size = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 106:
-#line 779 "../config_gram.y"
-{
-      current_mem->num_pages = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 107:
-#line 785 "../config_gram.y"
-{
-      current_mem->min_write_delay = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 108:
-#line 791 "../config_gram.y"
-{
-      current_mem->max_write_delay = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 109:
-#line 797 "../config_gram.y"
-{
-      current_mem->pwroff_after_write = yyvsp[0]->primary == K_YES ? 1 : 0;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 110:
-#line 803 "../config_gram.y"
-{
-      current_mem->readback[0] = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 111:
-#line 809 "../config_gram.y"
-{
-      current_mem->readback[1] = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 112:
-#line 816 "../config_gram.y"
-{
-      current_mem->mode = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 113:
-#line 822 "../config_gram.y"
-{
-      current_mem->delay = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 114:
-#line 828 "../config_gram.y"
-{
-      current_mem->blocksize = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 115:
-#line 834 "../config_gram.y"
-{
-      current_mem->readsize = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 116:
-#line 840 "../config_gram.y"
-{
-      current_mem->pollindex = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 117:
-#line 846 "../config_gram.y"
-{
+  }
+    break;
+
+  case 106:
+#line 778 "../config_gram.y"
+    {
+      current_mem->paged = (yyvsp[0])->primary == K_YES ? 1 : 0;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 107:
+#line 784 "../config_gram.y"
+    {
+      current_mem->size = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 108:
+#line 790 "../config_gram.y"
+    {
+      current_mem->wordsize = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 109:
+#line 796 "../config_gram.y"
+    {
+      current_mem->page_size = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 110:
+#line 802 "../config_gram.y"
+    {
+      current_mem->num_pages = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 111:
+#line 808 "../config_gram.y"
+    {
+      current_mem->min_write_delay = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 112:
+#line 814 "../config_gram.y"
+    {
+      current_mem->max_write_delay = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 113:
+#line 820 "../config_gram.y"
+    {
+      current_mem->pwroff_after_write = (yyvsp[0])->primary == K_YES ? 1 : 0;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 114:
+#line 826 "../config_gram.y"
+    {
+      current_mem->readback[0] = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 115:
+#line 832 "../config_gram.y"
+    {
+      current_mem->readback[1] = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 116:
+#line 839 "../config_gram.y"
+    {
+      current_mem->mode = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 117:
+#line 845 "../config_gram.y"
+    {
+      current_mem->delay = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 118:
+#line 851 "../config_gram.y"
+    {
+      current_mem->blocksize = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 119:
+#line 857 "../config_gram.y"
+    {
+      current_mem->readsize = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 120:
+#line 863 "../config_gram.y"
+    {
+      current_mem->pollindex = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 121:
+#line 869 "../config_gram.y"
+    {
     { 
       int opnum;
       OPCODE * op;
 
-      opnum = which_opcode(yyvsp[-2]);
+      opnum = which_opcode((yyvsp[-2]));
       op = avr_new_opcode();
       parse_cmdbits(op);
       current_mem->op[opnum] = op;
 
-      free_token(yyvsp[-2]);
+      free_token((yyvsp[-2]));
     }
-  ;
-    break;}
-}
-   /* the action file gets copied in in place of this dollarsign */
-#line 543 "/usr/share/bison.simple"
+  }
+    break;
+
+
+      default: break;
+    }
+
+/* Line 1126 of yacc.c.  */
+#line 2426 "../config_gram.c"
 
   yyvsp -= yylen;
   yyssp -= yylen;
-#ifdef YYLSP_NEEDED
-  yylsp -= yylen;
-#endif
 
-#if YYDEBUG != 0
-  if (yydebug)
-    {
-      short *ssp1 = yyss - 1;
-      fprintf (stderr, "state stack now");
-      while (ssp1 != yyssp)
-	fprintf (stderr, " %d", *++ssp1);
-      fprintf (stderr, "\n");
-    }
-#endif
 
+  YY_STACK_PRINT (yyss, yyssp);
+
   *++yyvsp = yyval;
 
-#ifdef YYLSP_NEEDED
-  yylsp++;
-  if (yylen == 0)
-    {
-      yylsp->first_line = yylloc.first_line;
-      yylsp->first_column = yylloc.first_column;
-      yylsp->last_line = (yylsp-1)->last_line;
-      yylsp->last_column = (yylsp-1)->last_column;
-      yylsp->text = 0;
-    }
-  else
-    {
-      yylsp->last_line = (yylsp+yylen-1)->last_line;
-      yylsp->last_column = (yylsp+yylen-1)->last_column;
-    }
-#endif
 
-  /* Now "shift" the result of the reduction.
-     Determine what state that goes to,
-     based on the state we popped back to
-     and the rule number reduced by.  */
+  /* Now `shift' the result of the reduction.  Determine what state
+     that goes to, based on the state we popped back to and the rule
+     number reduced by.  */
 
   yyn = yyr1[yyn];
 
-  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
-  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
+  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
+  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
     yystate = yytable[yystate];
   else
-    yystate = yydefgoto[yyn - YYNTBASE];
+    yystate = yydefgoto[yyn - YYNTOKENS];
 
   goto yynewstate;
 
-yyerrlab:   /* here on detecting error */
 
-  if (! yyerrstatus)
-    /* If not already recovering from an error, report this error.  */
+/*------------------------------------.
+| yyerrlab -- here on detecting error |
+`------------------------------------*/
+yyerrlab:
+  /* If not already recovering from an error, report this error.  */
+  if (!yyerrstatus)
     {
       ++yynerrs;
-
-#ifdef YYERROR_VERBOSE
+#if YYERROR_VERBOSE
       yyn = yypact[yystate];
 
-      if (yyn > YYFLAG && yyn < YYLAST)
+      if (YYPACT_NINF < yyn && yyn < YYLAST)
 	{
-	  int size = 0;
-	  char *msg;
-	  int x, count;
+	  int yytype = YYTRANSLATE (yychar);
+	  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
+	  YYSIZE_T yysize = yysize0;
+	  YYSIZE_T yysize1;
+	  int yysize_overflow = 0;
+	  char *yymsg = 0;
+#	  define YYERROR_VERBOSE_ARGS_MAXIMUM 5
+	  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
+	  int yyx;
 
-	  count = 0;
-	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
-	  for (x = (yyn < 0 ? -yyn : 0);
-	       x < (sizeof(yytname) / sizeof(char *)); x++)
-	    if (yycheck[x + yyn] == x)
-	      size += strlen(yytname[x]) + 15, count++;
-	  msg = (char *) malloc(size + 15);
-	  if (msg != 0)
+#if 0
+	  /* This is so xgettext sees the translatable formats that are
+	     constructed on the fly.  */
+	  YY_("syntax error, unexpected %s");
+	  YY_("syntax error, unexpected %s, expecting %s");
+	  YY_("syntax error, unexpected %s, expecting %s or %s");
+	  YY_("syntax error, unexpected %s, expecting %s or %s or %s");
+	  YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
+#endif
+	  char *yyfmt;
+	  char const *yyf;
+	  static char const yyunexpected[] = "syntax error, unexpected %s";
+	  static char const yyexpecting[] = ", expecting %s";
+	  static char const yyor[] = " or %s";
+	  char yyformat[sizeof yyunexpected
+			+ sizeof yyexpecting - 1
+			+ ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
+			   * (sizeof yyor - 1))];
+	  char const *yyprefix = yyexpecting;
+
+	  /* Start YYX at -YYN if negative to avoid negative indexes in
+	     YYCHECK.  */
+	  int yyxbegin = yyn < 0 ? -yyn : 0;
+
+	  /* Stay within bounds of both yycheck and yytname.  */
+	  int yychecklim = YYLAST - yyn;
+	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
+	  int yycount = 1;
+
+	  yyarg[0] = yytname[yytype];
+	  yyfmt = yystpcpy (yyformat, yyunexpected);
+
+	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
+	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
+	      {
+		if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
+		  {
+		    yycount = 1;
+		    yysize = yysize0;
+		    yyformat[sizeof yyunexpected - 1] = '\0';
+		    break;
+		  }
+		yyarg[yycount++] = yytname[yyx];
+		yysize1 = yysize + yytnamerr (0, yytname[yyx]);
+		yysize_overflow |= yysize1 < yysize;
+		yysize = yysize1;
+		yyfmt = yystpcpy (yyfmt, yyprefix);
+		yyprefix = yyor;
+	      }
+
+	  yyf = YY_(yyformat);
+	  yysize1 = yysize + yystrlen (yyf);
+	  yysize_overflow |= yysize1 < yysize;
+	  yysize = yysize1;
+
+	  if (!yysize_overflow && yysize <= YYSTACK_ALLOC_MAXIMUM)
+	    yymsg = (char *) YYSTACK_ALLOC (yysize);
+	  if (yymsg)
 	    {
-	      strcpy(msg, "parse error");
-
-	      if (count < 5)
+	      /* Avoid sprintf, as that infringes on the user's name space.
+		 Don't have undefined behavior even if the translation
+		 produced a string with the wrong number of "%s"s.  */
+	      char *yyp = yymsg;
+	      int yyi = 0;
+	      while ((*yyp = *yyf))
 		{
-		  count = 0;
-		  for (x = (yyn < 0 ? -yyn : 0);
-		       x < (sizeof(yytname) / sizeof(char *)); x++)
-		    if (yycheck[x + yyn] == x)
-		      {
-			strcat(msg, count == 0 ? ", expecting `" : " or `");
-			strcat(msg, yytname[x]);
-			strcat(msg, "'");
-			count++;
-		      }
+		  if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
+		    {
+		      yyp += yytnamerr (yyp, yyarg[yyi++]);
+		      yyf += 2;
+		    }
+		  else
+		    {
+		      yyp++;
+		      yyf++;
+		    }
 		}
-	      yyerror(msg);
-	      free(msg);
+	      yyerror (yymsg);
+	      YYSTACK_FREE (yymsg);
 	    }
 	  else
-	    yyerror ("parse error; also virtual memory exceeded");
+	    {
+	      yyerror (YY_("syntax error"));
+	      goto yyexhaustedlab;
+	    }
 	}
       else
 #endif /* YYERROR_VERBOSE */
-	yyerror("parse error");
+	yyerror (YY_("syntax error"));
     }
 
-  goto yyerrlab1;
-yyerrlab1:   /* here on error raised explicitly by an action */
 
+
   if (yyerrstatus == 3)
     {
-      /* if just tried and failed to reuse lookahead token after an error, discard it.  */
+      /* If just tried and failed to reuse look-ahead token after an
+	 error, discard it.  */
 
-      /* return failure if at end of input */
-      if (yychar == YYEOF)
-	YYABORT;
-
-#if YYDEBUG != 0
-      if (yydebug)
-	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
-#endif
-
-      yychar = YYEMPTY;
+      if (yychar <= YYEOF)
+        {
+	  /* Return failure if at end of input.  */
+	  if (yychar == YYEOF)
+	    YYABORT;
+        }
+      else
+	{
+	  yydestruct ("Error: discarding", yytoken, &yylval);
+	  yychar = YYEMPTY;
+	}
     }
 
-  /* Else will try to reuse lookahead token
-     after shifting the error token.  */
+  /* Else will try to reuse look-ahead token after shifting the error
+     token.  */
+  goto yyerrlab1;
 
-  yyerrstatus = 3;		/* Each real token shifted decrements this */
 
-  goto yyerrhandle;
+/*---------------------------------------------------.
+| yyerrorlab -- error raised explicitly by YYERROR.  |
+`---------------------------------------------------*/
+yyerrorlab:
 
-yyerrdefault:  /* current state does not do anything special for the error token. */
+  /* Pacify compilers like GCC when the user code never invokes
+     YYERROR and the label yyerrorlab therefore never appears in user
+     code.  */
+  if (0)
+     goto yyerrorlab;
 
-#if 0
-  /* This is wrong; only states that explicitly want error tokens
-     should shift them.  */
-  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
-  if (yyn) goto yydefault;
-#endif
+yyvsp -= yylen;
+  yyssp -= yylen;
+  yystate = *yyssp;
+  goto yyerrlab1;
 
-yyerrpop:   /* pop the current state because it cannot handle the error token */
 
-  if (yyssp == yyss) YYABORT;
-  yyvsp--;
-  yystate = *--yyssp;
-#ifdef YYLSP_NEEDED
-  yylsp--;
-#endif
+/*-------------------------------------------------------------.
+| yyerrlab1 -- common code for both syntax error and YYERROR.  |
+`-------------------------------------------------------------*/
+yyerrlab1:
+  yyerrstatus = 3;	/* Each real token shifted decrements this.  */
 
-#if YYDEBUG != 0
-  if (yydebug)
+  for (;;)
     {
-      short *ssp1 = yyss - 1;
-      fprintf (stderr, "Error: state stack now");
-      while (ssp1 != yyssp)
-	fprintf (stderr, " %d", *++ssp1);
-      fprintf (stderr, "\n");
-    }
-#endif
+      yyn = yypact[yystate];
+      if (yyn != YYPACT_NINF)
+	{
+	  yyn += YYTERROR;
+	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
+	    {
+	      yyn = yytable[yyn];
+	      if (0 < yyn)
+		break;
+	    }
+	}
 
-yyerrhandle:
+      /* Pop the current state because it cannot handle the error token.  */
+      if (yyssp == yyss)
+	YYABORT;
 
-  yyn = yypact[yystate];
-  if (yyn == YYFLAG)
-    goto yyerrdefault;
 
-  yyn += YYTERROR;
-  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
-    goto yyerrdefault;
-
-  yyn = yytable[yyn];
-  if (yyn < 0)
-    {
-      if (yyn == YYFLAG)
-	goto yyerrpop;
-      yyn = -yyn;
-      goto yyreduce;
+      yydestruct ("Error: popping", yystos[yystate], yyvsp);
+      YYPOPSTACK;
+      yystate = *yyssp;
+      YY_STACK_PRINT (yyss, yyssp);
     }
-  else if (yyn == 0)
-    goto yyerrpop;
 
   if (yyn == YYFINAL)
     YYACCEPT;
 
-#if YYDEBUG != 0
-  if (yydebug)
-    fprintf(stderr, "Shifting error token, ");
-#endif
-
   *++yyvsp = yylval;
-#ifdef YYLSP_NEEDED
-  *++yylsp = yylloc;
-#endif
 
+
+  /* Shift the error token. */
+  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);
+
   yystate = yyn;
   goto yynewstate;
 
- yyacceptlab:
-  /* YYACCEPT comes here.  */
-  if (yyfree_stacks)
-    {
-      free (yyss);
-      free (yyvs);
-#ifdef YYLSP_NEEDED
-      free (yyls);
+
+/*-------------------------------------.
+| yyacceptlab -- YYACCEPT comes here.  |
+`-------------------------------------*/
+yyacceptlab:
+  yyresult = 0;
+  goto yyreturn;
+
+/*-----------------------------------.
+| yyabortlab -- YYABORT comes here.  |
+`-----------------------------------*/
+yyabortlab:
+  yyresult = 1;
+  goto yyreturn;
+
+#ifndef yyoverflow
+/*-------------------------------------------------.
+| yyexhaustedlab -- memory exhaustion comes here.  |
+`-------------------------------------------------*/
+yyexhaustedlab:
+  yyerror (YY_("memory exhausted"));
+  yyresult = 2;
+  /* Fall through.  */
 #endif
-    }
-  return 0;
 
- yyabortlab:
-  /* YYABORT comes here.  */
-  if (yyfree_stacks)
+yyreturn:
+  if (yychar != YYEOF && yychar != YYEMPTY)
+     yydestruct ("Cleanup: discarding lookahead",
+		 yytoken, &yylval);
+  while (yyssp != yyss)
     {
-      free (yyss);
-      free (yyvs);
-#ifdef YYLSP_NEEDED
-      free (yyls);
+      yydestruct ("Cleanup: popping",
+		  yystos[*yyssp], yyvsp);
+      YYPOPSTACK;
+    }
+#ifndef yyoverflow
+  if (yyss != yyssa)
+    YYSTACK_FREE (yyss);
 #endif
-    }
-  return 1;
+  return yyresult;
 }
-#line 862 "../config_gram.y"
 
 
+#line 885 "../config_gram.y"
+
+
 #if 0
 static char * vtypestr(int type)
 {
@@ -2130,3 +2861,4 @@
 }
 
 
+
Index: G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/config_gram.h
===================================================================
--- G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/config_gram.h	(revision 1)
+++ G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/config_gram.h	(working copy)
@@ -1,99 +1,241 @@
-#ifndef YYSTYPE
-#define YYSTYPE int
+/* A Bison parser, made by GNU Bison 2.1.  */
+
+/* Skeleton parser for Yacc-like parsing with Bison,
+   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005 Free Software Foundation, Inc.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor,
+   Boston, MA 02110-1301, USA.  */
+
+/* As a special exception, when this file is copied by Bison into a
+   Bison output file, you may use that output file without restriction.
+   This special exception was added by the Free Software Foundation
+   in version 1.24 of Bison.  */
+
+/* Tokens.  */
+#ifndef YYTOKENTYPE
+# define YYTOKENTYPE
+   /* Put the tokens into the symbol table, so that GDB and other debuggers
+      know about them.  */
+   enum yytokentype {
+     K_READ = 258,
+     K_WRITE = 259,
+     K_READ_LO = 260,
+     K_READ_HI = 261,
+     K_WRITE_LO = 262,
+     K_WRITE_HI = 263,
+     K_LOADPAGE_LO = 264,
+     K_LOADPAGE_HI = 265,
+     K_WRITEPAGE = 266,
+     K_CHIP_ERASE = 267,
+     K_PGM_ENABLE = 268,
+     K_MEMORY = 269,
+     K_PAGE_SIZE = 270,
+     K_PAGED = 271,
+     K_BAUDRATE = 272,
+     K_BS2 = 273,
+     K_BUFF = 274,
+     K_CHIP_ERASE_DELAY = 275,
+     K_DEDICATED = 276,
+     K_DEFAULT_PARALLEL = 277,
+     K_DEFAULT_PROGRAMMER = 278,
+     K_DEFAULT_SERIAL = 279,
+     K_DESC = 280,
+     K_DEVICECODE = 281,
+     K_STK500_DEVCODE = 282,
+     K_AVR910_DEVCODE = 283,
+     K_EEPROM = 284,
+     K_ERRLED = 285,
+     K_FLASH = 286,
+     K_ID = 287,
+     K_IO = 288,
+     K_JTAG_MKII = 289,
+     K_LOADPAGE = 290,
+     K_MAX_WRITE_DELAY = 291,
+     K_MIN_WRITE_DELAY = 292,
+     K_MISO = 293,
+     K_MOSI = 294,
+     K_NUM_PAGES = 295,
+     K_PAGEL = 296,
+     K_PAR = 297,
+     K_PARALLEL = 298,
+     K_PART = 299,
+     K_PGMLED = 300,
+     K_PROGRAMMER = 301,
+     K_PSEUDO = 302,
+     K_PWROFF_AFTER_WRITE = 303,
+     K_RDYLED = 304,
+     K_READBACK_P1 = 305,
+     K_READBACK_P2 = 306,
+     K_READMEM = 307,
+     K_RESET = 308,
+     K_RETRY_PULSE = 309,
+     K_SERBB = 310,
+     K_SERIAL = 311,
+     K_SCK = 312,
+     K_SIZE = 313,
+     K_STK500 = 314,
+     K_STK500V2 = 315,
+     K_AVR910 = 316,
+     K_BUTTERFLY = 317,
+     K_TYPE = 318,
+     K_VCC = 319,
+     K_VFYLED = 320,
+     K_NO = 321,
+     K_YES = 322,
+     K_TIMEOUT = 323,
+     K_STABDELAY = 324,
+     K_CMDEXEDELAY = 325,
+     K_SYNCHLOOPS = 326,
+     K_BYTEDELAY = 327,
+     K_POLLVALUE = 328,
+     K_POLLINDEX = 329,
+     K_PREDELAY = 330,
+     K_POSTDELAY = 331,
+     K_POLLMETHOD = 332,
+     K_MODE = 333,
+     K_DELAY = 334,
+     K_BLOCKSIZE = 335,
+     K_READSIZE = 336,
+     K_ALLOWFULLPAGEBITSTREAM = 337,
+     K_ENABLEPAGEPROGRAMMING = 338,
+     K_HAS_JTAG = 339,
+     K_IDR = 340,
+     K_RAMPZ = 341,
+     K_SPMCR = 342,
+     K_EECR = 343,
+     TKN_COMMA = 344,
+     TKN_EQUAL = 345,
+     TKN_SEMI = 346,
+     TKN_TILDE = 347,
+     TKN_NUMBER = 348,
+     TKN_STRING = 349,
+     TKN_ID = 350,
+     K_WORD_SIZE = 351,
+     K_DEFAULT_FASTWRITE = 352,
+     K_DEFAULT_FASTVERIFY = 353
+   };
 #endif
-#define	K_READ	257
-#define	K_WRITE	258
-#define	K_READ_LO	259
-#define	K_READ_HI	260
-#define	K_WRITE_LO	261
-#define	K_WRITE_HI	262
-#define	K_LOADPAGE_LO	263
-#define	K_LOADPAGE_HI	264
-#define	K_WRITEPAGE	265
-#define	K_CHIP_ERASE	266
-#define	K_PGM_ENABLE	267
-#define	K_MEMORY	268
-#define	K_PAGE_SIZE	269
-#define	K_PAGED	270
-#define	K_BAUDRATE	271
-#define	K_BS2	272
-#define	K_BUFF	273
-#define	K_CHIP_ERASE_DELAY	274
-#define	K_DEDICATED	275
-#define	K_DEFAULT_PARALLEL	276
-#define	K_DEFAULT_PROGRAMMER	277
-#define	K_DEFAULT_SERIAL	278
-#define	K_DESC	279
-#define	K_DEVICECODE	280
-#define	K_STK500_DEVCODE	281
-#define	K_AVR910_DEVCODE	282
-#define	K_EEPROM	283
-#define	K_ERRLED	284
-#define	K_FLASH	285
-#define	K_ID	286
-#define	K_IO	287
-#define	K_JTAG_MKII	288
-#define	K_LOADPAGE	289
-#define	K_MAX_WRITE_DELAY	290
-#define	K_MIN_WRITE_DELAY	291
-#define	K_MISO	292
-#define	K_MOSI	293
-#define	K_NUM_PAGES	294
-#define	K_PAGEL	295
-#define	K_PAR	296
-#define	K_PARALLEL	297
-#define	K_PART	298
-#define	K_PGMLED	299
-#define	K_PROGRAMMER	300
-#define	K_PSEUDO	301
-#define	K_PWROFF_AFTER_WRITE	302
-#define	K_RDYLED	303
-#define	K_READBACK_P1	304
-#define	K_READBACK_P2	305
-#define	K_READMEM	306
-#define	K_RESET	307
-#define	K_RETRY_PULSE	308
-#define	K_SERBB	309
-#define	K_SERIAL	310
-#define	K_SCK	311
-#define	K_SIZE	312
-#define	K_STK500	313
-#define	K_STK500V2	314
-#define	K_AVR910	315
-#define	K_BUTTERFLY	316
-#define	K_TYPE	317
-#define	K_VCC	318
-#define	K_VFYLED	319
-#define	K_NO	320
-#define	K_YES	321
-#define	K_TIMEOUT	322
-#define	K_STABDELAY	323
-#define	K_CMDEXEDELAY	324
-#define	K_SYNCHLOOPS	325
-#define	K_BYTEDELAY	326
-#define	K_POLLVALUE	327
-#define	K_POLLINDEX	328
-#define	K_PREDELAY	329
-#define	K_POSTDELAY	330
-#define	K_POLLMETHOD	331
-#define	K_MODE	332
-#define	K_DELAY	333
-#define	K_BLOCKSIZE	334
-#define	K_READSIZE	335
-#define	K_ALLOWFULLPAGEBITSTREAM	336
-#define	K_ENABLEPAGEPROGRAMMING	337
-#define	K_HAS_JTAG	338
-#define	K_IDR	339
-#define	K_RAMPZ	340
-#define	K_SPMCR	341
-#define	K_EECR	342
-#define	TKN_COMMA	343
-#define	TKN_EQUAL	344
-#define	TKN_SEMI	345
-#define	TKN_TILDE	346
-#define	TKN_NUMBER	347
-#define	TKN_STRING	348
-#define	TKN_ID	349
+/* Tokens.  */
+#define K_READ 258
+#define K_WRITE 259
+#define K_READ_LO 260
+#define K_READ_HI 261
+#define K_WRITE_LO 262
+#define K_WRITE_HI 263
+#define K_LOADPAGE_LO 264
+#define K_LOADPAGE_HI 265
+#define K_WRITEPAGE 266
+#define K_CHIP_ERASE 267
+#define K_PGM_ENABLE 268
+#define K_MEMORY 269
+#define K_PAGE_SIZE 270
+#define K_PAGED 271
+#define K_BAUDRATE 272
+#define K_BS2 273
+#define K_BUFF 274
+#define K_CHIP_ERASE_DELAY 275
+#define K_DEDICATED 276
+#define K_DEFAULT_PARALLEL 277
+#define K_DEFAULT_PROGRAMMER 278
+#define K_DEFAULT_SERIAL 279
+#define K_DESC 280
+#define K_DEVICECODE 281
+#define K_STK500_DEVCODE 282
+#define K_AVR910_DEVCODE 283
+#define K_EEPROM 284
+#define K_ERRLED 285
+#define K_FLASH 286
+#define K_ID 287
+#define K_IO 288
+#define K_JTAG_MKII 289
+#define K_LOADPAGE 290
+#define K_MAX_WRITE_DELAY 291
+#define K_MIN_WRITE_DELAY 292
+#define K_MISO 293
+#define K_MOSI 294
+#define K_NUM_PAGES 295
+#define K_PAGEL 296
+#define K_PAR 297
+#define K_PARALLEL 298
+#define K_PART 299
+#define K_PGMLED 300
+#define K_PROGRAMMER 301
+#define K_PSEUDO 302
+#define K_PWROFF_AFTER_WRITE 303
+#define K_RDYLED 304
+#define K_READBACK_P1 305
+#define K_READBACK_P2 306
+#define K_READMEM 307
+#define K_RESET 308
+#define K_RETRY_PULSE 309
+#define K_SERBB 310
+#define K_SERIAL 311
+#define K_SCK 312
+#define K_SIZE 313
+#define K_STK500 314
+#define K_STK500V2 315
+#define K_AVR910 316
+#define K_BUTTERFLY 317
+#define K_TYPE 318
+#define K_VCC 319
+#define K_VFYLED 320
+#define K_NO 321
+#define K_YES 322
+#define K_TIMEOUT 323
+#define K_STABDELAY 324
+#define K_CMDEXEDELAY 325
+#define K_SYNCHLOOPS 326
+#define K_BYTEDELAY 327
+#define K_POLLVALUE 328
+#define K_POLLINDEX 329
+#define K_PREDELAY 330
+#define K_POSTDELAY 331
+#define K_POLLMETHOD 332
+#define K_MODE 333
+#define K_DELAY 334
+#define K_BLOCKSIZE 335
+#define K_READSIZE 336
+#define K_ALLOWFULLPAGEBITSTREAM 337
+#define K_ENABLEPAGEPROGRAMMING 338
+#define K_HAS_JTAG 339
+#define K_IDR 340
+#define K_RAMPZ 341
+#define K_SPMCR 342
+#define K_EECR 343
+#define TKN_COMMA 344
+#define TKN_EQUAL 345
+#define TKN_SEMI 346
+#define TKN_TILDE 347
+#define TKN_NUMBER 348
+#define TKN_STRING 349
+#define TKN_ID 350
+#define K_WORD_SIZE 351
+#define K_DEFAULT_FASTWRITE 352
+#define K_DEFAULT_FASTVERIFY 353
 
 
+
+
+#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
+typedef int YYSTYPE;
+# define yystype YYSTYPE /* obsolescent; will be withdrawn */
+# define YYSTYPE_IS_DECLARED 1
+# define YYSTYPE_IS_TRIVIAL 1
+#endif
+
 extern YYSTYPE yylval;
+
+
+
Index: G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/config_gram.y
===================================================================
--- G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/config_gram.y	(revision 1)
+++ G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/config_gram.y	(working copy)
@@ -165,6 +165,9 @@
 %token TKN_NUMBER
 %token TKN_STRING
 %token TKN_ID
+%token K_WORD_SIZE
+%token K_DEFAULT_FASTWRITE
+%token K_DEFAULT_FASTVERIFY
 
 %start configuration
 
@@ -201,6 +204,21 @@
     strncpy(default_serial, $3->value.string, PATH_MAX);
     default_serial[PATH_MAX-1] = 0;
     free_token($3);
+  } |
+  K_DEFAULT_FASTWRITE TKN_EQUAL TKN_NUMBER TKN_SEMI {
+  	FastWrite = $3->value.number;
+  	if (FastWrite != 0) {
+  		fprintf(stderr,"use fast write by default\n");
+  	}
+    free_token($3);
+  } |
+
+  K_DEFAULT_FASTVERIFY TKN_EQUAL TKN_NUMBER TKN_SEMI {
+  	FastVerify = $3->value.number;
+  	if (FastVerify != 0) {
+  		fprintf(stderr,"use fast verify by default\n");
+  	}
+    free_token($3);
   }
 ;
 
@@ -768,6 +786,11 @@
       free_token($3);
     } |
 
+  K_WORD_SIZE            TKN_EQUAL TKN_NUMBER
+    {
+      current_mem->wordsize = $3->value.number;
+      free_token($3);
+    } |
 
   K_PAGE_SIZE       TKN_EQUAL TKN_NUMBER
     {
Index: G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/jtagmkII.c
===================================================================
--- G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/jtagmkII.c	(revision 1)
+++ G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/jtagmkII.c	(working copy)
@@ -1150,14 +1150,16 @@
 
 
 static int jtagmkII_paged_write(PROGRAMMER * pgm, AVRPART * p, AVRMEM * m,
-				int page_size, int n_bytes)
+				int page_size, int n_bytes, unsigned long addr)
 {
-  int addr, block_size;
+  int block_size;
   unsigned char *cmd;
   unsigned char *resp;
   int status, tries;
   long otimeout = serial_recv_timeout;
-
+  unsigned long max_addr;
+  unsigned long low_addr;
+  
   if (verbose >= 2)
     fprintf(stderr, "%s: jtagmkII_paged_write(.., %s, %d, %d)\n",
 	    progname, m->desc, page_size, n_bytes);
@@ -1185,11 +1187,14 @@
   if (page_size == 0) page_size = 256;
 
   serial_recv_timeout = 100;
-  for (addr = 0; addr < n_bytes; addr += page_size) {
-    report_progress(addr, n_bytes,NULL);
 
-    if ((n_bytes-addr) < page_size)
-      block_size = n_bytes - addr;
+  max_addr = addr + n_bytes;
+  low_addr = addr;
+  for (addr = addr; addr < max_addr; addr += page_size) {
+    report_progress(addr - low_addr, n_bytes,NULL);
+
+    if ((max_addr-addr) < page_size)
+      block_size = max_addr - addr;
     else
       block_size = page_size;
     if (verbose >= 3)
@@ -1265,13 +1270,15 @@
 }
 
 static int jtagmkII_paged_load(PROGRAMMER * pgm, AVRPART * p, AVRMEM * m,
-			       int page_size, int n_bytes)
+			       int page_size, int n_bytes, unsigned long addr)
 {
-  int addr, block_size;
+  int block_size;
   unsigned char cmd[10];
   unsigned char *resp;
   int status, tries;
   long otimeout = serial_recv_timeout;
+  unsigned long max_addr;
+  unsigned long low_addr;
 
   if (verbose >= 2)
     fprintf(stderr, "%s: jtagmkII_paged_load(.., %s, %d, %d)\n",
@@ -1290,11 +1297,13 @@
   }
 
   serial_recv_timeout = 100;
-  for (addr = 0; addr < n_bytes; addr += page_size) {
-    report_progress(addr, n_bytes,NULL);
+  max_addr = addr + n_bytes;
+  low_addr = addr;
+  for (addr = addr; addr < max_addr; addr += page_size) {
+    report_progress(addr-low_addr, n_bytes ,NULL);
 
-    if ((n_bytes-addr) < page_size)
-      block_size = n_bytes - addr;
+    if ((max_addr-addr) < page_size)
+      block_size = max_addr - addr;
     else
       block_size = page_size;
     if (verbose >= 3)
Index: G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/lexer.l
===================================================================
--- G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/lexer.l	(revision 1)
+++ G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/lexer.l	(working copy)
@@ -129,6 +129,8 @@
 default_parallel { yylval=NULL; return K_DEFAULT_PARALLEL; }
 default_programmer { yylval=NULL; return K_DEFAULT_PROGRAMMER; }
 default_serial   { yylval=NULL; return K_DEFAULT_SERIAL; }
+default_fastwrite { yylval=NULL; return K_DEFAULT_FASTWRITE; }
+default_fastverify { yylval=NULL; return K_DEFAULT_FASTVERIFY; }
 devicecode       { yylval=NULL; return K_DEVICECODE; }
 eecr             { yylval=NULL; return K_EECR; }
 eeprom           { yylval=NULL; return K_EEPROM; }
@@ -147,6 +149,7 @@
 num_banks        { yylval=NULL; return K_NUM_PAGES; }
 num_pages        { yylval=NULL; return K_NUM_PAGES; }
 page_size        { yylval=NULL; return K_PAGE_SIZE; }
+word_size        { yylval=NULL; return K_WORD_SIZE; }
 paged            { yylval=NULL; return K_PAGED; }
 pagel            { yylval=NULL; return K_PAGEL; }
 par              { yylval=NULL; return K_PAR; }
@@ -187,7 +190,6 @@
 readsize        { yylval=NULL; return K_READSIZE; }
 
 
-
 dedicated        { yylval=new_token(K_DEDICATED); return K_DEDICATED; }
 io               { yylval=new_token(K_IO); return K_IO; }
 pseudo           { yylval=new_token(K_PSEUDO); return K_PSEUDO; }
